#!/bin/sh
awk 'BEGIN { FS="|"; } {
	mep  = $1;
	pnom = $2;
	gsub(/ /, "", mep);
	sub(/^ /, "", pnom);
	fpos = index(pnom, " ") + 1;
	nom = pnom;
	clen = 6;
	while (toupper(substr(nom, 0, clen)) != substr(nom, 0, clen)) {
		if (nom ~ /^v[ao]n /)
			break;
		if (nom !~ /^de Dios/ && nom ~ /^de /)
			break;
		if (nom ~ /^dos /)
			break;
		pos = index(nom, " ");
		if (pos == 0)
			break;
		nom = substr(nom, pos+1);
		while ((len = index(nom, ".")) == 2)
			nom = substr(nom, len+1);
	}
	sub(/^ /, "", nom);
	gsub(/  /, " ", nom);
	snom = substr(pnom, fpos);
	fend = index(snom, " ") - 1;
	#if (nom == "SCHMID")
	if (nom == "SCHMID" || nom == "COSTA" || nom == "EVANS" || nom == "MANN" || nom == "MARTIN" || nom == "MAYER" || nom == "MÜLLER" || nom == "SCHRÖDER" || nom == "MARTINEZ")
	printf "%s:%s, %s\n", mep, nom, substr(snom, 0, fend);
	else
	printf "%s:%s\n", mep, nom, substr(snom, 0, fend);
	#printf "%s\n", nom;
} ' pnom.out |
		sort -f -t: +1 
