$nvotes=7;
$mep=0;
$groups=0;
$targets=0;
$current_group = '';
print "<table border=1>";

while (<>) {


      if (! (/:/)) {
      		next;
      }
      
      ($group,undef) = (/^([^:]*):/);
      if ($group ne $current_group) {
      		if ($mep > 0) {&print_group};
      		print "<tr><td colwidth=21> $group </td></tr>\n";
      		$current_group = $group;
      }
      $mep++;
      chomp;
      @f = split(':');      
      #s/^[\s\d\.]* : //;
      $line{$mep} = $_;
      ($votes{$mep} = $line{$mep}) =~ s/^[^:]*:[^:]*:[^:]*:[^:]*://;
      $score{$mep}=0;
	$wscore{$mep}=0;
	$total{$mep}=0;
      if ($targets < 1) {
      
      	      # pick up Target pattern
	      for ($vote=1;$vote<=$nvotes;$vote++) {
		   $ballot = $f[2*$vote + 3];
		   $bval =0;
		   if ($ballot eq '+') {$bval=0.5};
		   if ($ballot eq '-') {$bval = -0.5};

		   #print "  $ballot  :  $bval \n";
		   $friend_vote{$vote}=$bval;
	      }
	      $score{$mep}=0;
	      $targets=1;
      } elsif ($targets < 2) {
      
      		# pick up Anti-Target pattern
	      for ($vote=1;$vote<=$nvotes;$vote++) {
		   $ballot = $f[2*$vote + 3];
		   $bval =0;
		   if ($ballot eq '+') {$bval=0.5};
		   if ($ballot eq '-') {$bval = -0.5};

		   #print "  $ballot  :  $bval \n";
		   $weight{$vote} = abs($bval - $friend_vote{$vote});
	           $score{$mep} += abs($bval - $friend_vote{$vote});
	           $wscore{$mep} += 2 * $weight{$vote} * abs($bval - $friend_vote{$vote});
	           $total{$mep} += abs($bval);
	      }
	      $targets=2;
      } else {
	      for ($vote=1;$vote<=$nvotes;$vote++) {
		   $ballot = $f[2*$vote + 3];
		   $bval =0;
		   if ($ballot eq '+') {$bval=0.5};
		   if ($ballot eq '-') {$bval = -0.5};

	           $score{$mep} += abs($bval - $friend_vote{$vote});
		   $wscore{$mep} += 2 * $weight{$vote} * abs($bval - $friend_vote{$vote});
	           $total{$mep} += abs($bval);
		   #print "  $ballot  :  $bval  :  $score{$mep}\n";
	     }
      }
      if ($f[3] eq " -") {$wscore{$mep} = 999};
      $country{$mep} = $f[2];
}      			
if ($mep > 0) {&print_group};
      
      	   
sub by_score {
	($wscore{$b} <=> $wscore{$a})  
	||  ($score{$b} <=> $score{$a})  
	||  ($total{$b} <=> $total{$a})  
	||  ($votes{$a} cmp $votes{$b})
	||  ($country{$a} cmp $country{$b})
	||  ($line{$a} cmp $line{$b});
}

sub text_print_group {
	foreach $i (sort by_score (1..$mep)) {
		printf('%4.1f',$wscore{$i});
		print " : $line{$i}\n";
	}
	$mep = 0;
}
      	   

sub print_group {
	foreach $i (sort by_score (1..$mep)) {
		if ($wscore{$i} == 999) {
			$ws='-'
		} else {
			$ws = sprintf('%4.1f',$wscore{$i});
		};
      		print "<tr><td>$ws";
      		print "</td>";
      		my @f = split(/:/,$line{$i});
      		my $group = $f[0];
      		my $name = $f[1];
      		my $country = $f[2];
      		my $score = $f[3];
  		print "<td>" .$name. "</td>";
  		print "<td>" .$country. "</td>";
	      	for (my $vote=1;$vote<=$nvotes;$vote++) {
		   	my $ballot = $f[2*$vote+3];
		   	my $bval =0;
		   	if ($ballot eq '+') {$bval=0.5};
		   	if ($ballot eq '-') {$bval = -0.5};

		    	my $diff = abs($bval - $friend_vote{$vote});
		        if (($targets < 2) || $weight{$vote}) {
		        	if ($diff == 1.0)  {$bcol = '#000000';$fcol ='#ffffff';};
		        	if ($diff == 0.5)  {$bcol = '#a0a0a0';$fcol ='#000000';};
		        	if ($diff == 0.0)  {$bcol = '#ffffff';$fcol ='#000000';};
		        } else {
		        	if ($diff == 1.0)  {$bcol = '#181818';$fcol ='#ffffff';};
		        	if ($diff == 0.5)  {$bcol = '#a0a0a0';$fcol ='#000000';};
		        	if ($diff == 0.0)  {$bcol = '#dddddd';$fcol ='#000000';};
		        }
		        if ($ballot eq " ") {
    				print "<td bgcolor=$bcol><font color=$fcol>$ballot</font></td>";
    			} else {
    				print "<td bgcolor=$bcol><font color=$fcol>$vote:$ballot</font></td>";
    			}
	      	}
      		print "</tr>\n";
      	}
      	$mep=0;
}
     
      

